<template>
  <div id="unit" class="flex-row">
    <div class="basic-main" @keyup.enter="search">
      <div class="flex dangqian" v-if="!show">
        <criteria-paged :model="model"  v-ref:paged>
          <criteria partial='criteria' @condition-changed='$parent.selfSearch' v-ref:cri>
            <div novalidate class="form-horizontal select-overspread container-fluid auto" partial >
              <div class="row">
                <div class="col-sm-2 form-group">
                  <label for="startDate" class="font_normal_body">开始日期</label>
                  <datepicker id="startDate" placeholder="开始日期" style="width:60%"
                              v-model="model.startDate"
                              :value.sync="model.startDate"
                              :format="'yyyy-MM-dd 00:00:00'"
                              :show-reset-button="true">
                  </datepicker>
                </div>
                <div class="col-sm-2 form-group">
                  <label for="endDate" class="font_normal_body">结束日期</label>
                  <datepicker id="endDate" placeholder="结束日期" style="width:60%"
                              v-model="model.endDate"
                              :value.sync="model.endDate"
                              :format="'yyyy-MM-dd 23:59:59'"
                              :show-reset-button="true">
                  </datepicker>
                </div>
                <div class="col-sm-2 form-group" v-show="false">
                  <label class="font_normal_body">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </label>
                  <res-select restype='department'
                              @res-select="$parent.$parent.getdep"
                              :parentresid="$parent.$parent.depresid"
                              :initresid='$parent.$parent.depid'>
                  </res-select>
                </div>

                <div class="span" style="float:right;">
                  <button class="button_search button_spacing" @click="search()">查询</button>

                  <export-excel :data="$parent.$parent.getCondition"
                                :field="$parent.$parent.getfield"
                                :footer="$parent.$parent.footer"
                                :header="$parent.$parent.other"
                                sqlurl="rs/logic/applyExportfile"
                                sql-name="apply-stair-anzhuang"
                                template-name='每月安装收入明细表'
                                :choose-col="true"></export-excel>
                  <print-data-self :model="$parent.model" :field="$parent.$parent.getfield"
                                   :defaultfield="$parent.$parent.defaultfield" printName="每月安装收入明细表"
                                   :sumsmodel="$parent.$parent.sumsmodel" :sum-field="$parent.$parent.sumField" :page-sum="$parent.$parent.pageSum"
                                   :start-date="$parent.$parent.startDate" :end-date="$parent.$parent.endDate"
                  ></print-data-self>
                </div>
              </div>
            </div>
          </criteria>
          <data-grid :model="model" partial='list' class="list_area table_sy" v-ref:grid :classname="$parent.classname">
            <template partial='head'>
              <tr>
                <th>
                  <nobr>序号</nobr>
                </th>
                <th>
                  <nobr>工程项目</nobr>
                </th>
                <th>
                  <nobr>收款时间</nobr>
                </th>
                <th>
                  <nobr>安装户数</nobr>
                </th>
                <th>
                  <nobr>发票金额</nobr>
                </th>
                <th>
                  <nobr>税额</nobr>
                </th>
              </tr>
            </template>
            <template partial='body'>
              <td style="text-align:center">
                <nobr>{{$index+1}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.name}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.fdate}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.num}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.fee}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.shui}}</nobr>
              </td>
            </template>
            <template partial='foot'></template>
          </data-grid>
        </criteria-paged>
        <table class="table-hover">
          <tr style="position: relative" class="table-bordered">
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;color: #5CB95C;font-weight: bold" >
              报表统计时间
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold" v-if="startDate==endDate">
              {{startDate}}
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold" v-else>
              {{startDate+" 至 "+endDate}}
            </td>
          </tr>
          <tr style="position: relative" class="table-bordered">
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;color: #5CB95C;font-weight: bold">
              汇总信息
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              安装户数:&emsp;{{sumsmodel.num.toFixed(2)}}
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              发票金额:&emsp;{{sumsmodel.fee.toFixed(2)}}
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</template>
<script>
import {PagedList, HttpResetClass} from 'vue-client'
import defaultPrint from 'sale-client'
import exportConfig from 'sale-client'

let readySomething = async function (self) {
  self.$refs.paged.$refs.cri.model.startDate = self.$login.toStandardDateString() + ' 00:00:00'
  self.$refs.paged.$refs.cri.model.endDate = self.$login.toStandardDateString() + ' 23:59:59'
  self.sumsmodel = self.$refs.paged.$refs.grid.model.sums
}
export default {
  title: '每月安装收入明细表',
  props: ['data'],
  data() {
    return {
      depresid: [],
      userresid: [],
      f_orgid: this.$login.f.orgid,
      f_depid: this.$login.f.depids,
      f_operator_id: this.$login.f.id,
      operatorid: [],
      depid: [],
      orgname: '',
      depname: [],
      operatorname: '',
      orgCondtionStr: '1=1',
      data: {},
      other:[],
      footer:[],
      model: new PagedList('rs/sql/apply-stair-anzhuang', 20, {startDate: 'this.model.startDate', endDate: 'this.model.endDate', f_orgid: 'this.model.f_orgid'},{
        num:0,
        fee:0
      }),
      gasproperties:[],
      show:false,
      rowdata:{},
      residentialArea: [],
      modelval: [],
      startDate:"",
      endDate:"",
      inputtouPerson: [],
      printshow: false,
      all: false,
      fields: {},
      thead: '',
      tfoot: '',

      // 下拉框

      //合计数据
      sumsmodel: {},
      sumField: {
        'num': '安装户数', 'fee': '发票金额'
      },
      pageSum: {
        'num': '0.00',
        'fee': '0.00'
      },
      defaultfield: [],
      config: {
        defaultPrint: ['f_userinfo_code', 'f_user_name']
      },
      batchmoneyShow:false
    }
  },
  ready() {
    readySomething(this).then(() => {
      this.$emit('ready')
    }).catch((error) => {
      this.$emit('error', error)
    })
  },
  methods: {
    getotherfooter(){
      // this.$refs.paged.$refs.cri.$refs.exports.otherData=[];
      // this.$refs.paged.$refs.cri.$refs.exports.footerData=[];
      this.other=[];
      this.footer=[];
      let exportdata = this.getCondition;
      let otherInData=[];
      otherInData.push(`导出时间: ${this.$login.toStandardTimeString()}`);
      let footerData=[],exportfield=this.getfield;
      footerData.push("合计");
      let self =this;
      // for(var field in self.sumsmodel){
      //   console.log("当前数据"+JSON.stringify(self.sumsmodel))
      //   footerData.push(`${exportfield[field]}合计:${self.sumsmodel[field]}`);
      // }
      this.footer.push(footerData);
      this.other.push(otherInData);
    },
    search(){
      this.$refs.paged.$refs.cri.search()
    },
    selfSearch(args) {
      let orgcondition = ' f_orgid in (' + this.f_orgid + ')'
      if (this.f_depid[0]) {
        orgcondition += " and f_depid in("+this.f_depid.toString()+')'
      }
      if(this.f_operator_id[0]) {
        orgcondition += ' and f_operator_id in (' + this.f_operator_id + ')'
      }
      this.startDate=this.$refs.paged.$refs.cri.model.startDate.substring(0,10)
      this.endDate=this.$refs.paged.$refs.cri.model.endDate.substring(0,10)
      this.orgCondtionStr=orgcondition
      this.$refs.paged.$refs.cri.model.f_orgid = orgcondition
      this.model.search(args.f_orgid, args.model)
      this.sumsmodel = this.$refs.paged.$refs.grid.model.sums
    },
    getRes (obj) {
      this.orgname = obj.res[0]
      this.depresid = obj.resids
      this.f_orgid = obj.resids
    },
    getdep (obj, val) {
      this.depname = val
      this.userresid = obj
      this.f_depid = obj
    },
    getuser ( obj, val) {
      this.operatorname = val[0]
      this.f_operator_id = obj
    },
    stamp() {
      this.all = false
      //默认选择要打印的列
      this.modelval = defaultPrint.config
      this.fields = this.getfield
      console.log('所有打印字段', this.fields)
      this.printshow = true
      this.put()
    },
    put() {
      // 对Modelval进行排序
      this.sortModelval()
      this.thead = `<tr><th colspan=${this.modelval.length}>每月安装收入明细表</th></tr><tr>`
      for (let key of this.modelval) {
        this.thead += '<th>' + this.fields[key] + '</th>'
      }
      this.thead += '</tr>'
    },
    print() {
      this.$refs.print.PrintAsFile()
      this.printshow = false
    },
    dealmsg(val) {
      console.log('---------------dealmsg')
      this.rowdata=val
      this.show=true
      val.model = this.model.model
      this.$dispatch('deal-msg', val)
    },
    close() {
      this.printshow = false
      this.all = false
    },
    // 对选择的列进行排序
    sortModelval() {
      let sortModel = []
      Object.keys(this.fields).forEach((key) => {
        if (this.modelval.includes(key)) {
          sortModel.push(key)
        }
      })
      this.modelval = sortModel
      console.log('选择的打印的字段', this.modelval)
    },
    userTypeChange () {
      this.gasproperties=[]
      if(this.$refs.paged.$refs.criteria.model !==null) {
        this.$refs.paged.$refs.criteria.model.f_gasproperties=''
        this.gasproperties = this.$appdata.getParam(this.$refs.paged.$refs.criteria.model.f_user_type[0])
      }
      else{
        this.gasproperties =[{label: '全部', value: ''}]
      }
    },
  },
  watch: {
    'all'(val) {
      if (val) {
        this.modelval = this.bodyData
      } else {
        this.modelval = defaultPrint.config
        this.put()
      }
    },
    'modelval.length'() {
      this.put()
    },
    sumsmodel:{
      handler: function(val) {
        this.getotherfooter();
      },
      deep: true
    }
  },
  computed: {
    getCondition() {
      return {
        startDate: this.$refs.paged.$refs.cri.model.startDate,
        endDate: this.$refs.paged.$refs.cri.model.endDate,
        f_orgid: this.orgCondtionStr

      }

    },
    getfield() {
      return exportConfig.apply_stair
    },
    whetherpaies () {
      return [
        {label: '全部', value: ''},
        {label: '已缴费', value: '是'},
        {label: '未缴费', value: '否'}
      ]
    },
    usertypes() {
      return [{label: ' 全部 ', value: ''}, ...this.$appdata.getParam('用户类型')]
    }

  }
}
</script>
<style scoped>

.dangqian{
  height: 90%!important;
}
</style>
